/** APP CONSTANTS **/
var appPath = 'http://localhost:8080/mysites/caixalivre/';
var TEMPLATE_POLL_INTERVAL = 5000;
var TEMPLATE_STORE = 1;
var TOTAL_CAIXAS = 6;

/** END APP CONSTANTS **/

var CaixaLivreApp = angular.module('CaixaLivreApp', []);

/** SERVICES **/

/**
 * Envia o caixa que está livre
 * Serviço: CaixaLivre(caixa, function returnCB() {...});
 */
CaixaLivreApp.factory('CaixaLivre', ['$http', function($http) {
    return function(caixa, callerCB) {
        $http({
            method: 'POST',
            url: appPath + '/app/caixa_livre.php',
            data: "store=" + TEMPLATE_STORE + "&cashier=" + caixa.idx,
            headers: {'Content-Type': 'application/x-www-form-urlencoded'}
        }).then(function successCB(response) {
            // foi tudo certo
            callerCB(response.data);
        }, function errorCB(response) {
            console.log("erro no caixa Livre");
            console.log(response);
            callerCB(false);
        });
    };
}]);

/** CONTROLLERS **/
CaixaLivreApp.controller('CaixaCtrl', ['$scope', '$timeout', 'CaixaLivre',
    function($scope, $timeout, CaixaLivre) {
        $scope.caixa = 0;
        $scope.optionsCaixas = [];
        for (var i = 1; i <= TOTAL_CAIXAS; i++) {
            $scope.optionsCaixas.push({idx: i, label: 'Caixa ' + i});
        }
        

        $scope.proximoCliente = function() {
            // desabilita o botão
            $scope.chamando = true;
            $scope.error = "";
            $scope.success = "";

            // aguarda 1 segundo para enviar a requisição. Só para o usuário ver que está funcionando
            $timeout(function() {
                // envia para o PHP o chamado
                CaixaLivre($scope.caixa, function(response) {
                    $scope.chamando = false;

                    if (response.error) {
                        $scope.error = response.error;
                    } else {
                        $scope.success = "Chamada feita!";
                    }
                });
            }, 1000);
        };

    }
]);