/** APP CONSTANTS **/
var appPath = 'http://localhost:8080/mysites/caixalivre/';
var TEMPLATE_POLL_INTERVAL = 5000;
var TEMPLATE_STORE = 1;
var TOTAL_CAIXAS = 6;

/** END APP CONSTANTS **/

var CaixaLivreTemplate = angular.module('CaixaLivreTemplate', ['ngAudio']);

/** SERVICES **/

/**
 * Busca os caixas livres no servidor
 * Serviço: pollCaixaLivre(function returnCB() {...});
 */
CaixaLivreTemplate.factory('pollCaixaLivre', ['$http', function($http) {
    return function(callback) {
        $http({
            method: 'POST',
            url: appPath + '/app/poll_caixa.php',
            data: 'store=' + TEMPLATE_STORE,
            headers: {'Content-Type': 'application/x-www-form-urlencoded'}
        }).then(function successCB(response) {
            // foi tudo certo
            callback(response.data);
        }, function errorCB(response) {
            console.log("erro no template poll");
            console.log(response);
        });
    };
}]);


/** CONTROLLERS **/
CaixaLivreTemplate.controller('TemplateCtrl', ['$scope', '$interval', '$timeout', 'pollCaixaLivre', 'ngAudio', 
    function($scope, $interval, $timeout, pollCaixaLivre, ngAudio) {
        $scope.caixaLivre = 'Nenhum';
        $scope.audio = ngAudio.load(appPath + '/app/assets/mp3/two_tone_doorbell.mp3');

        $scope.changeCaixaLivre = function(caixa) {
            console.log("caixa", caixa);
            $scope.caixaLivre = caixa;
            $scope.alert = true;
            $scope.audio.play();
            // mantém o alerta de caixa por 2 segundos
            $timeout(function() {
                $scope.alert = false;
            }, 2000);
        };

        $interval(function() {
            pollCaixaLivre(function(retorno) {
                if (retorno.cashier) {
                    $scope.changeCaixaLivre(retorno.cashier);
                }
            })
        }, TEMPLATE_POLL_INTERVAL);
    }
]);